/*
 * @(#)SendToBackCommand.java 5.1
 *
 */

package CH.ifa.draw.standard;

import java.util.*;
import CH.ifa.draw.util.*;
import CH.ifa.draw.framework.*;

/**
 * A command to send the selection to the back of the drawing.
 */
public class SendToBackCommand extends Command {

    protected DrawingEditor fEditor;

   /**
    * Constructs a send to back command.
    * @param name the command name
    * @param view the target view
    */
    public SendToBackCommand(String name, DrawingEditor editor) {
        super(name);
        fEditor = editor;
    }

    public void execute() {
       DrawingView view = fEditor.view();
       FigureEnumeration k = new ReverseFigureEnumerator(view.selectionZOrdered());
       while (k.hasMoreElements()) {
            view.drawing().sendToBack(k.nextFigure());
        }
        view.checkDamage();
    }

    public boolean isExecutable() {
        return fEditor.view().selectionCount() > 0;
    }

}


