package de.renew.call;

import de.renew.simulator.*;
import de.renew.unify.*;

class BlockExecutable implements EarlyExecutable {
  SynchronisationRequest synchronisation;
  BlockExecutable(SynchronisationRequest synchronisation) {
    this.synchronisation=synchronisation;
  }

  public int phase() {
    return BLOCK;
  }

  public long lockPriority() {
    return synchronisation.lockOrder;
  }

  public void lock() {
    synchronisation.lock.lock();
  }

  public void verify() throws Impossible {
    if (synchronisation.completed) {
      throw new Impossible();
    }
  }

  public void execute(Tracer tracer) {
    synchronisation.completed=true;
  }

  public void rollback() {
    // Nothing to do.
  }

  public void unlock() {
    synchronisation.lock.unlock();
  }
}
