package de.renew.database;

import de.renew.simulator.PlaceInstance;

public class TokenAction {
  private PlaceInstance placeInstance;
  private Object token;
  private String tokenID;

  TokenAction(PlaceInstance placeInstance, Object token) {
    this.placeInstance=placeInstance;
    this.token=token;
    // Precalculate token ID. It will be needed anyway.
    this.tokenID=placeInstance.getTokenID(token);
  }

  public PlaceInstance getPlaceInstance() {
    return placeInstance;
  }

  public Object getToken() {
    return token;
  }

  public Object getTokenID() {
    return tokenID;
  }

  public String getNetID() {
    return placeInstance.getNetInstance().getID();
  }

  public int getPlaceID() {
    return placeInstance.getPlace().getID();
  }

  public String getPlaceName() {
    return placeInstance.getPlace().toString();
  }
}
