package de.renew.formalism.fs;

import java.util.*;
import de.renew.shadow.*;
import de.uni_hamburg.fs.*;

public class FSShadowLookup extends ShadowLookup {

  /** Mapping from ShadowConcept to ConceptImpl. */
  private Hashtable conceptMap=new Hashtable();
  /** Mapping from ConceptImpl.Feature to ShadowConcept or ShadowAssoc. */
  private Hashtable appropMap=new Hashtable();
  /** Mapping from ShadowConcept to Partition of Subconcepts. */
  private Hashtable partitionMap=new Hashtable();

  public void setConcept(ShadowConcept shadowConcept, ConceptImpl concept) {
    conceptMap.put(shadowConcept, concept);
  }

  public ConceptImpl getConcept(ShadowConcept shadowConcept) {
    return (ConceptImpl)conceptMap.get(shadowConcept);
  }

    /*
  public ShadowConcept getShadowConcept(ConceptImpl concept) {
      // use inverse relation:
      Enumeration enum=conceptMap.keys();
      while (enum.hasMoreElements()) {
	  ShadowConcept key=(ShadowConcept)enum.nextElement();
	  if (conceptMap.get(key)==concept) {
	      return key;
	  }
      }
      throw new NoSuchElementException();
  }
    */

  public Enumeration allConcepts() {
    return conceptMap.keys();  // an enumeration of ConceptImpl-s
  }

  public void setApprop(ConceptImpl concept, Name feature,
			ShadowNetElement elem) {
      appropMap.put(concept.getName()+"."+feature,elem);
  }

  public ShadowNetElement getApprop(ConceptImpl concept, Name feature) {
      return (ShadowNetElement)appropMap.get(concept.getName()+"."+feature);
  }

  public void addToSubPartition(ShadowConcept supi, ConceptImpl sub)
      throws TypeException {
      Partition suppart=(Partition)partitionMap.get(supi);
      if (suppart==null) {
	  suppart=new Partition(sub);
	  partitionMap.put(supi,suppart);
      } else {
	  suppart.addConcept(sub);
      }
  }

}

