package de.renew.function;

import de.renew.unify.*;
import java.lang.reflect.Method;

import de.renew.util.ReflectionSerializer;
import java.io.IOException;

public abstract class AbstractMethodFunction implements Function {
  public abstract Object doFunction(Object obj, Object[] paramArr)
    throws Exception;

  public Object function(Object param) throws Impossible {
    Tuple tuple=(Tuple)param;
    if (tuple.getArity()!=2) {
      throw new Impossible();
    }
    Object obj=tuple.getComponent(0);
    Tuple args=(Tuple)tuple.getComponent(1);

    Object[] paramArr=new Object[args.getArity()];
    for (int i=0;i<paramArr.length;i++) {
      paramArr[i]=args.getComponent(i);
    }

    try {
      return doFunction(obj,paramArr);
    }
    catch (Exception e) {
      //e.printStackTrace();
      //if (e instanceof java.lang.reflect.InvocationTargetException) {
      //  ((java.lang.reflect.InvocationTargetException)e)
      //    .getTargetException().printStackTrace();
      //}
      throw new Impossible(
        "An exception occured during a method call.");
    }
  }
}
