/*
 * @(#)InhibitorConnection.java 5.1
 *
 */

package de.renew.gui;

import java.awt.*;
import java.util.*;
import java.io.IOException;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.standard.*;
import de.renew.simulator.*;
import de.renew.shadow.*;

public class DoubleArcConnection extends ArcConnection {
  public static final DoubleArcConnection DoubleArc
    = new DoubleArcConnection();

  public DoubleArcConnection() {
    setStartDecoration(null);
    setEndDecoration();
  }

  protected void setStartDecoration() {
    setStartDecoration(new DoubleArrowTip());
  }

  protected void setEndDecoration() {
    setEndDecoration(new DoubleArrowTip());
  }

  public int getArcType() {
    return ShadowArc.doubleOrdinary;
  }

  public void setAttribute(String name, Object value) {
    if (name.equals("ArrowMode")) {
      Integer intObj = (Integer) value;
      if (intObj != null) {
	int decoration = intObj.intValue();

	switch (decoration) {
	case ARROW_TIP_START:
	  setStartDecoration(new DoubleArrowTip());
	  setEndDecoration(null);
	  changed();
	  break;
	case ARROW_TIP_END:
	  setStartDecoration(null);
  	  setEndDecoration(new DoubleArrowTip());
	  changed();
	  break;
	}
      }
    } else {
      super.setAttribute(name,value);
    }
  }
}
