/*
 * @(#)DoubleArrowTip.java 5.1
 *
 */

package de.renew.gui;

import java.io.*;
import java.awt.*;

import CH.ifa.draw.framework.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.util.*;

/**
 * A double arrow tip line decoration.
 * @see PolyLineFigure
 */
public class DoubleArrowTip extends ArrowTip {

    /*
     * Serialization support.
     */
    private static final long serialVersionUID = -34591123673823638L;
    private int doubleArrowTipSerializedDataVersion = 1;

    public DoubleArrowTip() {}

    /**
     * Constructs an arrow tip with the given angle and radius.
     */
    public DoubleArrowTip(double angle,
      double outerRadius, double innerRadius, boolean filled)
    {
      super(angle,outerRadius,innerRadius,filled);
    }

    protected Polygon outline(int x, int y, double direction) {
        Polygon shape = new Polygon();

        shape.addPoint(x, y);
        addPointRelative(shape, x, y, fOuterRadius, direction - fAngle);
	int xx=x + (int) (fInnerRadius * Math.cos(direction));
	int yy=y - (int) (fInnerRadius * Math.sin(direction));
	shape.addPoint(xx, yy);
        addPointRelative(shape, xx, yy, fOuterRadius, direction - fAngle);
        addPointRelative(shape, xx, yy, fInnerRadius, direction);
        addPointRelative(shape, xx, yy, fOuterRadius, direction + fAngle);
	shape.addPoint(xx, yy);
        addPointRelative(shape, x, y, fOuterRadius, direction + fAngle);
        // shape.addPoint(x,y); // Closing the polygon (TEG 97-04-23)
	// closing is done automatically !!! (FUW 98-04-20)
        return shape;
    }

}
