package de.renew.gui;

import CH.ifa.draw.framework.*;
import de.renew.unify.Tuple;
import de.renew.formalism.java.*;
import de.renew.shadow.*;
import java.awt.*;

public class JavaMode implements RenewMode {

  CPNSimulation fSimulation=null;

  public ShadowCompiler getCompiler() {
      return new JavaNetCompiler(false,false,false);
  }

  public CPNSimulation getSimulation() {
      if (fSimulation==null)
	  fSimulation=new CPNSimulation(getCompiler(),false);
      return fSimulation;
  }

  public Figure getTokenFigure(Object token)
   {
      if (token instanceof Tuple && ((Tuple)token).getArity() > 0) {
         return new TupleFigure(this,(Tuple)token);
      } else {
         return new TokenFigure(this,token);
      }
   }

  public void createAdditionalTools(CPNApplication editor, Panel palette) {
  }	

  public void createAdditionalMenus(CPNApplication editor, MenuBar menu) {
  }

  public Tool createPlaceTool(DrawingEditor editor) {
    // Delegate back to drawing editor.
    return null;
  }

  public Tool createTransitionTool(DrawingEditor editor) {
    // Delegate back to drawing editor.
    return null;
  }

  public boolean wantClock() {
    return false;
  }

  public boolean wantAux() {
    return false;
  }

  public String getAuxFigureName() {
    return null;
  }

  public String getAuxToolName() {
    return null;
  }
}
