package de.renew.gui.fs;

import java.io.*;
import java.awt.*;
import java.util.Vector;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.figures.TextFigure;
import CH.ifa.draw.figures.ShortestDistanceConnector;
import CH.ifa.draw.util.ColorMap;
import CH.ifa.draw.standard.*;
import de.renew.formalism.fs.*;
import de.renew.shadow.*;
import de.renew.gui.*;

public class FSNodeFigure extends TextFigure
  implements PlaceNodeFigure, TransitionNodeFigure {

  private String typeStr="";
  private static final int DEFAULT_ARC = 8;

  public FSNodeFigure(String type) {
    super(type);
    typeStr=type;
    setAttribute("FrameColor", ColorMap.color("Black"));
    setAttribute("FillColor", ColorMap.color("White"));
  }

  public FSNodeFigure() {
  	 this("");
  }

    public void drawBackground(Graphics g) {
        Rectangle r = displayBox();
        g.fillRoundRect(r.x, r.y, r.width, r.height, DEFAULT_ARC, DEFAULT_ARC);
    }

    public void drawFrame(Graphics g) {
        Rectangle r = displayBox();
        g.drawRoundRect(r.x, r.y, r.width-1, r.height-1,
			DEFAULT_ARC, DEFAULT_ARC);
    }

    public Insets connectionInsets() {
        return new Insets(DEFAULT_ARC/2, DEFAULT_ARC/2,
			  DEFAULT_ARC/2, DEFAULT_ARC/2);
    }

    public Connector connectorAt(int x, int y) {
        return new ShortestDistanceConnector(this); // just for demo purposes
    }

  public Vector handles() {
      Vector handles = super.handles();
      handles.addElement(new FeatureConnectionHandle(this));
      return handles;
  }

   public void setText(String text) {
   	typeStr = text;
      super.setText(typeStr);
   }

  public Rectangle displayBox() {
    Rectangle box = super.displayBox();
    return new Rectangle(box.x-5, box.y, box.width+10, box.height);
  }

  /** Build a shadow in the given shadow net.
    *  This shadow is stored as well as returned.
    */
  public ShadowNetElement buildShadow(ShadowNet net) {
      return null;
  }

  /** Get the associated shadow, if any.
   */
  public ShadowNetElement getShadow() {
    return null;
  }

  public String getName() {
      return typeStr;
  }

  public void release() {
    super.release();
  }  

  public boolean canBeParent(ParentFigure figure) {
    return figure==null;
  }

}
