package de.renew.gui.fs;

import CH.ifa.draw.framework.Figure;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.framework.*;
import de.renew.formalism.fs.*;
import de.renew.shadow.*;
import de.renew.gui.*;

public class FeatureConnection
    extends LineConnection
    implements InscribableFigure
    {

  public final static FeatureConnection NormalArc = new FeatureConnection();

  public FeatureConnection() {
    setStartDecoration(null);
    setEndDecoration(new AssocArrowTip());
  }

  private ShadowNetElement shadow=null;

  /** Build a shadow in the given shadow net.
    *  This shadow is stored as well as returned.
    */
  public ShadowNetElement buildShadow(ShadowNet net) {
//      shadow = createShadow(getStartFSNode(),getEndFSNode());
//      shadow.context = this;
        return shadow;
  }

  //protected ShadowNetElement createShadow(ShadowFSNode from, ShadowFSNode to);

  /** Get the associated shadow, if any.
   */
  public ShadowNetElement getShadow() {
    return shadow;
  }

//  protected ShadowFSNode getStartFSNode() {
//      return getFSNode(startFigure());
//  }

//  protected ShadowFSNode getEndConcept() {
//      return getFSNode(endFigure());
//  }

//  private static ShadowFSNode getFSNode(Figure figure) {
//      if (canConnect(figure)) {
//	return (ShadowFSNode)((ShadowHolder)figure).getShadow();
//    } else {
//	return null;
//    }
//  }

  private static boolean canConnect(Figure figure) {
     return figure instanceof PlaceNodeFigure
         || figure instanceof TransitionNodeFigure
         || figure instanceof FSFigure;
  }

  public boolean canConnect(Figure start, Figure end) {
     return canConnect(start)
	 && canConnect(end);
  }

  public void release() {
    super.release();
//    if (shadow!=null)
//      shadow.discard();
  }  

  public void setAttribute(String name, Object value) {
    if (!name.equals("ArrowMode")) {
       super.setAttribute(name,value);
    }
  }

  /** Get the default text for a new inscription child.
   */
  public String getDefaultInscription() {
	  return "feat";
  }

}
