/*
 * @(#)FeatureConnectionHandle.java 5.1
 *
 */

package de.renew.gui.fs;

import java.awt.*;

import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.util.Geom;

/**
 * A handle to connect FSNodes to one another.
 *
 * @see ConnectionFigure
 */

public  class FeatureConnectionHandle extends ConnectionHandle {

    /**
     * Constructs a handle for the given owner
     */
    public FeatureConnectionHandle(Figure owner) {
        super(owner, RelativeLocator.center(), FeatureConnection.NormalArc);
    }

    /**
     * Connects the figures if the mouse is released over another
     * FSNode figure;
     * otherwise, a new figure is created!
     */
    public void invokeEnd(int x, int y, int anchorX, int anchorY, DrawingView view) {
        Connector target = findConnectionTarget(x, y, view.drawing());
        if (target == null) {
           Figure owner = owner();
           if (owner.findFigureInside(x,y)==null) {
               Figure endFigure=new FSNodeFigure("Type");
               Dimension d=endFigure.displayBox().getSize();
               int w2=d.width/2, h2=d.height/2;
               endFigure.displayBox(new Point(x-w2,y-h2),
		 new Point(x-w2+d.width,y-h2+d.height));
               view.drawing().add(endFigure);
           }
        }
        super.invokeEnd(x,y,anchorX,anchorY,view);
    }

}
