package de.renew.gui.xml;

import CH.ifa.draw.framework.*;
import collections.*;
import java.util.Enumeration;

public class OrderedFigureEnumeration implements FigureEnumeration {
  private Enumeration sorted;
  public OrderedFigureEnumeration(Enumeration enum) {
    LinkedList list=new LinkedList();
    list.appendElements(enum);
    list.sort(new Comparator() {
	public int compare(Object a, Object b) {
	  if (a instanceof FigureWithID &&
	      b instanceof FigureWithID)
	  {
	    int ida=((FigureWithID)a).getID();
	    int idb=((FigureWithID)b).getID();
	    if (ida<idb) {
	      return -1;
	    } else if (idb<ida) {
	      return 1;
	    } else {
	      return 0;
	    }
	  } else if (a instanceof FigureWithID) {
	    return -1;
	  } else if (b instanceof FigureWithID) {
	    return 1;
	  } else {
	    return 0;
	  }
	}
    });
    sorted=list.elements();
  }
  
  public boolean hasMoreElements() {
    return sorted.hasMoreElements();
  }
  public Object nextElement() {
    return sorted.nextElement();
  }
  public Figure nextFigure() {
    return (Figure)nextElement();
  }
}
