package de.renew.remote;

import java.rmi.*;
import java.rmi.server.*;

import de.renew.simulator.Transition;

/**
 * This class implements the <code>TransitionAccessor</code> interface
 * and nothing more.
 * <p>
 * </p>
 * TransitionAccessorImpl.java
 * Created: Sun Jul 16  2000
 * @author Michael Duvigneau
 */

public class TransitionAccessorImpl extends UnicastRemoteObject implements TransitionAccessor  {
  
  /**
   * The transition that is accessible by this accessor.
   */
  private Transition transition;

  /**
   * Creates a new transition accessor for the given transition.
   *
   * @param transition the transition to access
   * @exception java.rmi.RemoteException if an RMI failure occured.
   */  
  public TransitionAccessorImpl(Transition transition) throws RemoteException {
    super();
    this.transition = transition;
  }

  /* This method is specified by the Accessor interface. */
  public String asString() throws RemoteException {
    return transition.toString();
  }

  /* This method is specified by the TransitionAccessor interface. */
  public int getID() throws RemoteException {
    return transition.getID();
  }

} 
