package de.renew.util;

import collections.CollectionEnumeration;
import java.util.NoSuchElementException;

// I will wrap an ordinary enumeration and convert nulls
// to special NULL objects using the class Null.
//
// This is required, because the collection classes will not take nulls
// as arguments.

public class NullEnumeration implements CollectionEnumeration {
  private CollectionEnumeration enum;

  public NullEnumeration(CollectionEnumeration enum) {
    this.enum=enum;
  }
  
  public boolean hasMoreElements() {
    return enum.hasMoreElements();
  }
  public Object nextElement() throws NoSuchElementException {
    return Null.convert(enum.nextElement());
  }
  public boolean corrupted() {
    return enum.corrupted();
  }
  public int numberOfRemainingElements() {
    return enum.numberOfRemainingElements();
  }
}
