package de.uni_hamburg.fs;

import collections.*;
import java.util.*;

public class Subsumption {

  private UpdatableMap h=new HashedMap();

  public static boolean subsumes(Node thiz, Node that) {
      return new Subsumption().subsumes2(thiz,that);
  }

  private Subsumption() { }

  private boolean subsumes2(Node thiz, Node that) {
    if (h.includesKey(thiz))
      return h.at(thiz) == that;
    if (!thiz.getType().subsumes(that.getType()))
      return false;
    h.putAt(thiz,that);
    Enumeration features = thiz.featureNames();
    while (features.hasMoreElements()) {
      Name featureName = (Name)features.nextElement();
      Node thispost = thiz.delta(featureName);
      if (that.hasFeature(featureName)) {
	Node thatpost = that.delta(featureName);
	if (!subsumes2(thispost,thatpost))
	  return false;
      } else
	return false;
    }
    return true;
  }

}
